
	//sigma = 2.0
	//float filterCoeffs[14] = float[14](0.00101493587382722, 0.00454862701282552, 0.0158762682603361, 0.0431561715158126, 0.0913616158159147, 0.150629839321232,
	//						  0.193412542200052, 0.193412542200052, 0.150629839321232, 0.0913616158159147, 0.0431561715158126, 0.0158762682603361, 0.00454862701282546,
	//						  0.00101493587382722);

	//sigma = 1.5
	float filterCoeffs[7] = float[7](0.0366328453691940, 0.111280758478885, 0.216745321403708, 0.270682149496427, 0.216745321403708, 0.111280758478885, 0.0366328453691940);

#ifdef VERTEX_SHADER

	layout(location = 0) in vec3 position;

	void main()
	{
		gl_Position = vec4(position, 1.0);
	}
#endif


#ifdef GEOMETRY_SHADER

		layout(triangles, invocations = 6) in;
		layout(triangle_strip, max_vertices=18) out;
		
		uniform mat4 u_lightMatrices[6];

		out vec4 boxPosition_worldSpace;
		flat out int cubeFace;

		void main() 
		{
			gl_Layer = gl_InvocationID;
			for(int tri_vert = 0; tri_vert < 3; ++tri_vert) 
			{
				boxPosition_worldSpace = gl_in[tri_vert].gl_Position;
				gl_Position = u_lightMatrices[gl_Layer] * gl_in[tri_vert].gl_Position;
				cubeFace = gl_Layer;
				EmitVertex();
			}
			EndPrimitive();	
		}

#endif

#ifdef FRAGMENT_SHADER

	uniform samplerCube u_shadowCube;
	uniform mat3 u_startRotation;
	uniform mat3 u_RotationStep;

	in vec4 boxPosition_worldSpace;
	flat in int cubeFace;

	layout(location = 0) out vec2 out_BlurredMoments;

	void main()
	{
		vec3 center = boxPosition_worldSpace.xyz;

		vec2 blurred = vec2(0.0, 0.0);
		vec3 currDirection = u_startRotation * center;

		for(int i = 0;  i < 7; ++i)
		{
			blurred += texture(u_shadowCube, currDirection).rg * filterCoeffs[i];
			currDirection = u_RotationStep * currDirection;
		}


		out_BlurredMoments = blurred;
	}

#endif