#pragma once

#include "../../../LDEngine/Shader.h"
#include "../../../LDEngine/Log.h" 


namespace LD
{

class Blur : public Shader
{
public:

	enum BlurUniforms
	{
		u_shadowCube = 0,
		u_lightMatrices,
		u_resolution,
		u_startRotation,
		u_RotationStep,
		numberOfUniforms //kinda dirty.. this must be the last element of the uniform
	};

	enum BlurAttributes
	{
		position = 0,
		texCoords,
		numberOfAttributes
	};

	virtual GLint getUniform(int uniform)
	{
		return _uniforms[uniform];
	}
	
	Blur(LD_RenderPass passType) : Shader("Blur", passType)
	{
		std::vector<GLenum> shaderTypes;
		shaderTypes.push_back(GL_VERTEX_SHADER);
		shaderTypes.push_back(GL_GEOMETRY_SHADER);
		shaderTypes.push_back(GL_FRAGMENT_SHADER);		
		createShaderfromSource(shaderTypes, _passType);
		initUniforms();
	}


	private:
		GLint _uniforms [Blur::numberOfUniforms];


		void initUniforms()
		{
			_uniforms[u_shadowCube] = glGetUniformLocation(_program, "u_shadowCube");
			_uniforms[u_lightMatrices] = glGetUniformLocation(_program, "u_lightMatrices");
			_uniforms[u_resolution] = glGetUniformLocation(_program, "u_resolution");
			_uniforms[u_startRotation] = glGetUniformLocation(_program, "u_startRotation");
			_uniforms[u_RotationStep] = glGetUniformLocation(_program, "u_RotationStep");
		}
		
};


}
