
	#define M_PI 3.1415926535897932384626433832795
	
	float rescale(float p_max, float tailBegin)
	{
		return clamp((p_max - tailBegin) / (1.0 - tailBegin), 0.0, 1.0);
	}

	float shadowContribution(vec2 moments, float distFromVertex)
	{
		float p = 0.0;
		if(distFromVertex <= moments.x)
			p = 1.0;

		float var = max(moments.y - (moments.x*moments.x), 0.008);
		float d = distFromVertex - moments.x;
		float p_max = var / (var + d*d);

		p_max = rescale(p_max, 0.05);

		return max(p, p_max);
	}


	vec2 calcMoments(float dist)
	{
		float moment1 = dist;
		float dx = dFdx(dist);
		float dy = dFdy(dist);
		float moment2 = (dist*dist) + 0.25 * (dx*dx + dy*dy);
		return vec2(moment1, moment2);
	}

	void neutralizeRotation(inout mat4 matrix, float scale)
	{
		for(int i=0; i<3; i++ ) 
			for(int j=0; j<3; j++ ) {
				if ( i==j )
					matrix[i][j] = scale;
				else
					matrix[i][j] = 0.0f;
			}
	}

