#pragma once

#include "../../../LDEngine/Shader.h"
#include "../../../LDEngine/Log.h" 


namespace LD
{

	class FlatShader : public Shader
	{
	public:

		enum FlatShaderUniforms
		{
			u_mvp = 0,
			numberOfUniforms //kinda dirty.. this must be the last element of the uniform
		};

		enum FlatShaderAttributes
		{
			position = 0,
			numberOfAttributes
		};

		virtual GLint getUniform(int uniform)
		{
			return _uniforms[uniform];
		}

		FlatShader(LD_RenderPass passType) : Shader("FlatShader", passType)
		{
			std::vector<GLenum> shaderTypes;

			shaderTypes.push_back(GL_VERTEX_SHADER);
			shaderTypes.push_back(GL_FRAGMENT_SHADER);

			createShaderfromSource(shaderTypes, _passType);

			initUniforms();
		}

	private:
		GLint _uniforms [FlatShader::numberOfUniforms];

		void initUniforms()
		{
			_uniforms[u_mvp] = glGetUniformLocation(_program, "u_mvp");
		}

	};


}
