#pragma once

#include "../../../LDEngine/Shader.h"
#include "../../../LDEngine/Log.h" 


namespace LD
{

class MHBShader : public Shader
{
public:

	enum MHBShaderUniforms
	{
		u_modelViewMat = 0,
		numberOfUniforms //kinda dirty.. this must be the last element of the uniform
	};

	enum MHBShaderAttributes
	{
		mhtCoeff = 0,
		detail,
		normal,
		numberOfAttributes
	};

	virtual GLint getUniform(int uniform)
	{
		return _uniforms[uniform];
	}
	
	MHBShader(LD_RenderPass passType) : Shader("MHBShader", passType)
	{
		std::vector<GLenum> shaderTypes;

		shaderTypes.push_back(GL_VERTEX_SHADER);
		shaderTypes.push_back(GL_FRAGMENT_SHADER);
		
		createShaderfromSource(shaderTypes, _passType);

		initUniforms();
	}


	private:
		GLint _uniforms [MHBShader::numberOfUniforms];

		void initUniforms()
		{
		}
		
};


}
