
#ifdef VERTEX_SHADER

	#ifdef RenderPass_Shaded


		layout(location = 0) in vec2 Position;
		layout(location = 1) in vec2 texCoords;

		out vec2 vertexTexCoords;

		uniform mat4 u_mvp;

		void main()
		{
			vertexTexCoords = texCoords;
			gl_Position = u_mvp * vec4(Position, 0.0, 1.0);
		}
	#endif

	
#endif

#ifdef FRAGMENT_SHADER

	#ifdef RenderPass_Shaded
		
		
		in vec2 vertexTexCoords;

		out vec4 out_Color;

		uniform sampler2D u_textTexture;

		void main()
		{
			out_Color = texture(u_textTexture, vertexTexCoords).rgba;
		}

	#endif

#endif
